
#include <stdio.h>

#include "goring0.h"
#include "constants.h"

#define KPCR_ADDRESS 0xffdff000


unsigned short GetCS();

/**
 * Get the current value of CS
 */
unsigned short GetCS(){
	unsigned short my_cs;
	_asm{
		push eax
		mov ax, cs
		mov my_cs, ax
		pop eax
	}
	return my_cs;
}



int __cdecl main(int ac, char **av){

	unsigned short my_cs = 0;
	unsigned long val = 0;
	
    printf("GoRing0 controller loaded. %s %s\n", __DATE__, __TIME__);
	
	GoRing0();
	
	my_cs = GetCS();
	val = *(unsigned long*)(KPCR_ADDRESS+0x1c);
	
	GoRing3();
	
	
	printf("CS r0 = %x\n", (unsigned long) my_cs);
	
	my_cs = GetCS();
	
	printf("CS r3 = %x\n", (unsigned long) my_cs);
	
	printf("val = %08x\n", val);
	
    printf("GoRing0 controller unloaded. %s %s\n", __DATE__, __TIME__);
	
	getchar();
    
    return 0;
}

