#ifndef _HOOK_H
#define _HOOK_H

#include <ntdef.h>


#define MAKELONG(a, b) ((unsigned long) (((u_int16) (a)) | ((unsigned long) ((u_int16) (b))) << 16))

//Typedefs
typedef unsigned char u_int8;
typedef unsigned short u_int16;
typedef unsigned int u_int32;

/**
 * An IDT entry
 */
#pragma pack(1)
typedef struct {
	u_int16 low_offset;
	u_int16 selector;
	u_int8 unused_lo;
	u_int8 segment_type:4; //0x0E is an interrupt gate
	u_int8 system_segment_flag:1;
	u_int8 DPL:2; // descriptor privilege level
	u_int8 P:1; /* present */
	u_int16 hi_offset;
} IDTENTRY;
#pragma pack()


/**
 * Hook
 */
void Hook();

/**
 * Unhook
 */
void UnHook();


/**
 * Hook an interrupt handler
 */
void HookOneIDT(IDTENTRY* pIDT, u_int32 interrupt_number, u_int32* old_address, u_int32 new_address, u_int8 new_DPL, u_int8* old_DPL);

/**
 * Hook all IDTs.
 */
void HookAllIDTs(u_int32 interrupt_number, u_int32* old_addresses, u_int32* new_addresses, u_int8* new_DPLs, u_int8* old_DPLs);

/**
 * New page fault handler
 */
void interrupt_handler();

#endif
